from enum import Enum
from typing import Any, List
from fastapi import FastAPI, Response
from fastapi.datastructures import Default
from fastapi.responses import JSONResponse
from fastapi.routing import APIRoute
from fastapi.utils import generate_unique_id


def path(
        *,
        app:FastAPI,
        func:function,
        type:str,
        path: str,
        response_model: Any = Default(None),
        status_code: int | None = None,
        tags: List[str | Enum] | None = None,
        dependencies = None,
        summary: str | None = None,
        description: str | None = None,
        response_description: str = "Successful Response",
        responses = None,
        deprecated: bool | None = None,
        operation_id = None,
        response_model_include = None,
        response_model_exclude= None,
        response_model_by_alias: bool = True,
        response_model_exclude_unset: bool = False,
        response_model_exclude_defaults: bool = False,
        response_model_exclude_none: bool = False,
        include_in_schema: bool = True,
        response_class: type[Response] = Default(JSONResponse),
        name: str | None = None,
        callbacks = None,
        openapi_extra = None,
        generate_unique_id_function=Default(generate_unique_id)
    ):
    if type.casefold()=="get":
        app.get(path,
        response_model,
        status_code,
        tags,
        dependencies,
        summary,
        description,
        response_description,
        responses,
        deprecated,
        operation_id,
        response_model_include,
        response_model_exclude,
        response_model_by_alias,
        response_model_exclude_unset,
        response_model_exclude_defaults,
        response_model_exclude_none,
        include_in_schema,
        response_class,
        name,
        callbacks,
        openapi_extra,
        generate_unique_id_function)(func)

    if type.casefold()=='post':
        app.post(path,
        response_model,
        status_code,
        tags,
        dependencies,
        summary,
        description,
        response_description,
        responses,
        deprecated,
        operation_id,
        response_model_include,
        response_model_exclude,
        response_model_by_alias,
        response_model_exclude_unset,
        response_model_exclude_defaults,
        response_model_exclude_none,
        include_in_schema,
        response_class,
        name,
        callbacks,
        openapi_extra,
        generate_unique_id_function)(func)

    if type.casefold()=='put':
        app.put(path,
        response_model,
        status_code,
        tags,
        dependencies,
        summary,
        description,
        response_description,
        responses,
        deprecated,
        operation_id,
        response_model_include,
        response_model_exclude,
        response_model_by_alias,
        response_model_exclude_unset,
        response_model_exclude_defaults,
        response_model_exclude_none,
        include_in_schema,
        response_class,
        name,
        callbacks,
        openapi_extra,
        generate_unique_id_function)(func)

    if type.casefold=='delete':
        app.delete(path,
        response_model,
        status_code,
        tags,
        dependencies,
        summary,
        description,
        response_description,
        responses,
        deprecated,
        operation_id,
        response_model_include,
        response_model_exclude,
        response_model_by_alias,
        response_model_exclude_unset,
        response_model_exclude_defaults,
        response_model_exclude_none,
        include_in_schema,
        response_class,
        name,
        callbacks,
        openapi_extra,
        generate_unique_id_function)(func)

    if type.casefold()=='patch':
        app.patch(path,
        response_model,
        status_code,
        tags,
        dependencies,
        summary,
        description,
        response_description,
        responses,
        deprecated,
        operation_id,
        response_model_include,
        response_model_exclude,
        response_model_by_alias,
        response_model_exclude_unset,
        response_model_exclude_defaults,
        response_model_exclude_none,
        include_in_schema,
        response_class,
        name,
        callbacks,
        openapi_extra,
        generate_unique_id_function)(func)
